#include <sourcemod>
#include <sdkhooks>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>
#include <adminmenu>
#include <cstrike>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

public Plugin myinfo = 
{
	name = "Grenades Rounds", 
	author = "LanteJoula", 
	description = "Grenades Rounds", 
	version = "1.3", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

//ConVar

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_Round_End_Message;
ConVar gConVar_Round_Start_Message;
ConVar gConVar_ForceStop_Round_Message;

ConVar gConVar_Molotov_Round;
ConVar gConVar_HE_Round;
ConVar gConVar_Smoke_Round;
ConVar gConVar_Flash_Round;
ConVar gConVar_Decoy_Round;

ConVar gConVar_Molotov_Round_Health;
ConVar gConVar_HE_Round_Health;
ConVar gConVar_Smoke_Round_Health;
ConVar gConVar_Flash_Round_Health;
ConVar gConVar_Decoy_Round_Health;

ConVar gConVar_Start_Vote_Message;
ConVar gConVar_Votes_Resultes_Message;

//BOOL

bool MolotovRound = false;
bool HERound = false;
bool SmokeRound = false;
bool FlashBangRound = false;
bool DecoyRound = false;

bool MolotovRound1 = true;
bool HERound1 = true;
bool SmokeRound1 = true;
bool FlashBangRound1 = true;
bool DecoyRound1 = true;

//VOTES GRENADES ROUNDS

int Mode;

int yes;
int no;

bool ModeVoted = false;

bool StartVoting = false;

//ADMIN MENU

Handle hAdminMenu;

//KNIFE OFF

bool KnifeDamage = true;

public void OnPluginStart()
{
	LoadTranslations("grenadesrounds.phrases");
	
	//COMMANDS
	
	RegAdminCmd("sm_grenadesrounds", GrenadesRoundsMenu, ADMFLAG_GENERIC);
	RegAdminCmd("sm_gr", GrenadesRoundsMenu, ADMFLAG_GENERIC);
	
	//EVENTS
	
	HookEvent("round_end", OnRoundEnd);
	HookEvent("round_start", OnRoundStart1);
	
	//AutoExecConfig
	
	AutoExecConfig_SetFile("plugin.grenadesrounds");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_grenadesrounds_chat_prefix", "[{green}TAG{default}]", "Chat Prefix");
	
	gConVar_Round_End_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_round_end_message", "1", "Enable/Disable Message when Rounds End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Round_Start_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_round_start_message", "1", "Enable/Disable Message when Rounds Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_ForceStop_Round_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_forcestop_round_message", "1", "Enable/Disable Message when Staff Force Stop Rounds (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Molotov_Round = AutoExecConfig_CreateConVar("sm_grenadesrounds_molotov_round", "1", "Enable/Disable Molotov Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_HE_Round = AutoExecConfig_CreateConVar("sm_grenadesrounds_he_round", "1", "Enable/Disable HE Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Smoke_Round = AutoExecConfig_CreateConVar("sm_grenadesrounds_smoke_round", "1", "Enable/Disable Smoke Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Flash_Round = AutoExecConfig_CreateConVar("sm_grenadesrounds_flash_round", "1", "Enable/Disable Flash Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Decoy_Round = AutoExecConfig_CreateConVar("sm_grenadesrounds_decoy_round", "1", "Enable/Disable Decoy Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Molotov_Round_Health = AutoExecConfig_CreateConVar("sm_grenadesrounds_molotov_round_health", "150", "Enable/Disable Amount of Health when Start Molotov Round (Default = 150)", 0, true, 0.0, true, 1000.0);
	gConVar_HE_Round_Health = AutoExecConfig_CreateConVar("sm_grenadesrounds_he_round_health", "200", "Enable/Disable Amount of Health when Start HE Round (Default = 200)", 0, true, 0.0, true, 1000.0);
	gConVar_Smoke_Round_Health = AutoExecConfig_CreateConVar("sm_grenadesrounds_smoke_round_health", "1", "Enable/Disable Amount of Health when Start Smoke Round (Default = 1)", 0, true, 0.0, true, 1000.0);
	gConVar_Flash_Round_Health = AutoExecConfig_CreateConVar("sm_grenadesrounds_flash_round_health", "1", "Enable/Disable Amount of Health when Start Flash Round (Default = 1)", 0, true, 0.0, true, 1000.0);
	gConVar_Decoy_Round_Health = AutoExecConfig_CreateConVar("sm_grenadesrounds_decoy_round_health", "1", "Enable/Disable Amount of Health when Start Decoy Round (Default = 1)", 0, true, 0.0, true, 1000.0);
	
	gConVar_Start_Vote_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_start_vote_message", "1", "Enable/Disable the Message on Chat when Staff Start Vote (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Votes_Resultes_Message = AutoExecConfig_CreateConVar("sm_grenadesrounds_votes_results_message", "1", "Enable/Disable the Message on Chat with Votes Resultes (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//KNIFE OFF
	
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
		}
	}
	
	KnifeDamage = true;
	
	//RegPluginLibrary
	RegPluginLibrary("grenadesrounds");
}

//Prefix
//Prefix
//Prefix

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//PLUGIN
//PLUGIN
//PLUGIN

//MODE 1 - RONDA DE MOLOTOV
//MODE 2 - RONDA DE HE
//MODE 3 - RONDA DE SMOKE
//MODE 4 - RONDA DE FLASH
//MODE 5 - RONDA DE DECOY

public void OnMapStart()
{
	ModeVoted = false;
	
	yes = 0;
	no = 0;
}

public Action GrenadesRoundsMenu(int client, int args)
{
	OpenGrenadesRoundsMenu(client);
}

void OpenGrenadesRoundsMenu(int client)
{
	Menu menu = new Menu(mMenu);
	menu.SetTitle("%t\n ", "GrenadesRoundsMenuTitle");
	
	//MOLOTOV
	if (gConVar_Molotov_Round.BoolValue)
	{
		char PreStartMolotovMenu1[128];
		char PreStartMenu1[128];
		char ForceStopMolotovMenu1[128];
		
		if (!MolotovRound)
		{
			if (HERound1 && SmokeRound1 && FlashBangRound1 && DecoyRound1 && !StartVoting)
			{
				Format(PreStartMolotovMenu1, sizeof(PreStartMolotovMenu1), "%t", "PreStartMolotovMenu");
				menu.AddItem("1", PreStartMolotovMenu1);
			}
			else
			{
				Format(PreStartMenu1, sizeof(PreStartMenu1), "%t", "Voting or Round in Progress");
				menu.AddItem("1", PreStartMenu1, ITEMDRAW_DISABLED);
			}
		}
		else
		{
			Format(ForceStopMolotovMenu1, sizeof(ForceStopMolotovMenu1), "%t", "ForceStopMolotovMenu");
			menu.AddItem("2", ForceStopMolotovMenu1);
		}
	}
	
	//HE
	if (gConVar_HE_Round.BoolValue)
	{
		char PreStartHEMenu1[128];
		char PreStartMenuHEStartVoting1[128];
		char ForceStopHEMenu1[128];
		
		if (!HERound)
		{
			if (MolotovRound1 && SmokeRound1 && FlashBangRound1 && DecoyRound1 && !StartVoting)
			{
				Format(PreStartHEMenu1, sizeof(PreStartHEMenu1), "%t", "PreStartHEMenu");
				menu.AddItem("3", PreStartHEMenu1);
			}
			else
			{
				Format(PreStartMenuHEStartVoting1, sizeof(PreStartMenuHEStartVoting1), "%t", "Voting or Round in Progress");
				menu.AddItem("3", PreStartMenuHEStartVoting1, ITEMDRAW_DISABLED);
			}
		}
		else
		{
			Format(ForceStopHEMenu1, sizeof(ForceStopHEMenu1), "%t", "ForceStopHEMenu");
			menu.AddItem("4", ForceStopHEMenu1);
		}
	}
	
	//Smoke
	if (gConVar_Smoke_Round.BoolValue)
	{
		char PreStartSmokeMenu1[128];
		char PreStartMenuSmokeStartVoting1[128];
		char ForceStopSmokeMenu1[128];
		
		if (!SmokeRound)
		{
			if (MolotovRound1 && HERound1 && FlashBangRound1 && DecoyRound1 && !StartVoting)
			{
				Format(PreStartSmokeMenu1, sizeof(PreStartSmokeMenu1), "%t", "PreStartSmokeMenu");
				menu.AddItem("5", PreStartSmokeMenu1);
			}
			else
			{
				Format(PreStartMenuSmokeStartVoting1, sizeof(PreStartMenuSmokeStartVoting1), "%t", "Voting or Round in Progress");
				menu.AddItem("5", PreStartMenuSmokeStartVoting1, ITEMDRAW_DISABLED);
			}
		}
		else
		{
			Format(ForceStopSmokeMenu1, sizeof(ForceStopSmokeMenu1), "%t", "ForceStopSmokeMenu");
			menu.AddItem("6", ForceStopSmokeMenu1);
		}
	}
	
	//Flash
	if (gConVar_Flash_Round.BoolValue)
	{
		char PreStartFlashMenu1[128];
		char PreStartMenuFlashStartVoting1[128];
		char ForceStopFlashMenu1[128];
		
		if (!FlashBangRound)
		{
			if (MolotovRound1 && HERound1 && SmokeRound1 && DecoyRound1 && !StartVoting)
			{
				Format(PreStartFlashMenu1, sizeof(PreStartFlashMenu1), "%t", "PreStartFlashMenu");
				menu.AddItem("7", PreStartFlashMenu1);
			}
			else
			{
				Format(PreStartMenuFlashStartVoting1, sizeof(PreStartMenuFlashStartVoting1), "%t", "Voting or Round in Progress");
				menu.AddItem("7", PreStartMenuFlashStartVoting1, ITEMDRAW_DISABLED);
			}
		}
		else
		{
			Format(ForceStopFlashMenu1, sizeof(ForceStopFlashMenu1), "%t", "ForceStopFlashMenu");
			menu.AddItem("9", ForceStopFlashMenu1);
		}
	}
	
	//Decoy
	if (gConVar_Decoy_Round.BoolValue)
	{
		char PreStartDecoyMenu1[128];
		char PreStartMenuDecoyStartVoting1[128];
		char ForceStopDecoyMenu1[128];
		
		if (!DecoyRound)
		{
			if (MolotovRound1 && HERound1 && SmokeRound1 && FlashBangRound1 && !StartVoting)
			{
				Format(PreStartDecoyMenu1, sizeof(PreStartDecoyMenu1), "%t", "PreStartDecoyMenu");
				menu.AddItem("9", PreStartDecoyMenu1);
			}
			else
			{
				Format(PreStartMenuDecoyStartVoting1, sizeof(PreStartMenuDecoyStartVoting1), "%t", "Voting or Round in Progress");
				menu.AddItem("9", PreStartMenuDecoyStartVoting1, ITEMDRAW_DISABLED);
			}
		}
		else
		{
			Format(ForceStopDecoyMenu1, sizeof(ForceStopDecoyMenu1), "%t", "ForceStopDecoyMenu");
			menu.AddItem("10", ForceStopDecoyMenu1);
		}
	}
	
	menu.Display(client, MENU_TIME_FOREVER);
}

public int mMenu(Menu menu, MenuAction action, int client, int param2)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			char szItem[32];
			menu.GetItem(param2, szItem, sizeof(szItem));
			
			
			if (StrEqual(szItem, "1"))
			{
				Mode = -1;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteMolotovRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "2"))
			{
				MolotovRound = false;
				MolotovRound1 = true;
				
				if (gConVar_ForceStop_Round_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "MolotovRoundForceStop", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsValidClient(i))
					{
						SetEntProp(i, Prop_Data, "m_iHealth", 100);
						
						RemoveNades(i);
					}
				}
				
				KnifeDamage = true;
				
				ServerCommand("sv_infinite_ammo 0");
				
				SetDefaultValue("mp_buytime");
			}
			if (StrEqual(szItem, "3"))
			{
				Mode = -2;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteHERound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "4"))
			{
				HERound = false;
				HERound1 = true;
				
				if (gConVar_ForceStop_Round_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "HERoundForceStop", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsValidClient(i))
					{
						SetEntProp(i, Prop_Data, "m_iHealth", 100);
						
						RemoveNades(i);
					}
				}
				
				KnifeDamage = true;
				
				ServerCommand("sv_infinite_ammo 0");
				
				SetDefaultValue("mp_buytime");
			}
			if (StrEqual(szItem, "5"))
			{
				Mode = -3;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteSmokeRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "6"))
			{
				SmokeRound = false;
				SmokeRound1 = true;
				
				if (gConVar_ForceStop_Round_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "SmokeRoundForceStop", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsValidClient(i))
					{
						SetEntProp(i, Prop_Data, "m_iHealth", 100);
						
						RemoveNades(i);
					}
				}
				
				KnifeDamage = true;
				
				ServerCommand("sv_infinite_ammo 0");
				
				SetDefaultValue("mp_buytime");
			}
			if (StrEqual(szItem, "7"))
			{
				Mode = -4;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteFlashRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "8"))
			{
				FlashBangRound = false;
				FlashBangRound1 = true;
				
				if (gConVar_ForceStop_Round_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "FlashRoundForceStop", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsValidClient(i))
					{
						SetEntProp(i, Prop_Data, "m_iHealth", 100);
						
						RemoveNades(i);
					}
				}
				
				KnifeDamage = true;
				
				ServerCommand("sv_infinite_ammo 0");
				
				SetDefaultValue("mp_buytime");
			}
			if (StrEqual(szItem, "9"))
			{
				Mode = -5;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteDecoyRound", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "10"))
			{
				DecoyRound = false;
				DecoyRound1 = true;
				
				if (gConVar_ForceStop_Round_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "DecoyRoundForceStop", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsValidClient(i))
					{
						SetEntProp(i, Prop_Data, "m_iHealth", 100);
						
						RemoveNades(i);
					}
				}
				
				KnifeDamage = true;
				
				ServerCommand("sv_infinite_ammo 0");
				
				SetDefaultValue("mp_buytime");
			}
		}
		case MenuAction_End:
		{
			delete menu;
		}
	}
}

void StartVotingMenu()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))continue;
		Menu menu = new Menu(mVotingMenu);
		
		if (Mode == -1)
		{
			menu.SetTitle("%t", "VoteMolotovRound");
		}
		if (Mode == -2)
		{
			menu.SetTitle("%t", "VoteHERound");
		}
		if (Mode == -3)
		{
			menu.SetTitle("%t", "VoteSmokeRound");
		}
		if (Mode == -4)
		{
			menu.SetTitle("%t", "VoteFlashRound");
		}
		if (Mode == -5)
		{
			menu.SetTitle("%t", "VoteDecoyRound");
		}
		menu.AddItem("yes", "Sim");
		menu.AddItem("no", "Não");
		
		menu.Display(i, 10);
	}
	
	StartVoting = true;
	
	CreateTimer(15.0, tTimerCountVotes);
}

public int mVotingMenu(Menu menu, MenuAction action, int param1, int param2)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char szItem[32];
			menu.GetItem(param2, szItem, sizeof(szItem));
			if (StrEqual(szItem, "yes"))
			{
				if (CheckCommandAccess(param1, "", ADMFLAG_CUSTOM1))
				{
					yes++;
				}
				yes++;
			}
			else
			{
				if (CheckCommandAccess(param1, "", ADMFLAG_CUSTOM1))
				{
					no++;
				}
				no++;
			}
		}
	}
}

public Action tTimerCountVotes(Handle timer)
{
	if (yes > no)
	{
		if (Mode == -1 || Mode == -2 || Mode == -3 || Mode == -4 || Mode == -5 || Mode == -6)
		{
			ModeVoted = true;
		}
		
		if (gConVar_Votes_Resultes_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "VoteYes");
	}
	else
	{
		if (gConVar_Votes_Resultes_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "VoteNo");
		
		ModeVoted = false;
		
		StartVoting = false;
	}
	yes = 0;
	no = 0;
}

public Action OnRoundStart1(Event event, const char[] name, bool dontBroadcast)
{
	if (ModeVoted)
	{
		ModeVoted = false;
		
		StartVoting = false;
		
		if (Mode == -1)
		{
			MolotovRound = true;
			MolotovRound1 = false;
			
			if (gConVar_Round_Start_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "MolotovRoundStart", name);
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", gConVar_Molotov_Round_Health.IntValue);
					
					RemoveNades(i);
					
					int Primary = GetPlayerWeaponSlot(i, CS_SLOT_PRIMARY);
					int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
					int Grenade = GetPlayerWeaponSlot(i, CS_SLOT_GRENADE);
					
					if (Primary != -1)
					{
						RemovePlayerItem(i, Primary);
					}
					
					if (Secondary != -1)
					{
						RemovePlayerItem(i, Secondary);
					}
					
					if (Grenade != -1)
					{
						GivePlayerItem(i, "weapon_molotov");
					}
					else
					{
						GivePlayerItem(i, "weapon_molotov");
					}
				}
			}
			
			KnifeDamage = false;
			
			ServerCommand("sv_infinite_ammo 1");
			
			SetCvar("mp_buytime", "0");
		}
		if (Mode == -2)
		{
			HERound = true;
			HERound1 = false;
			
			if (gConVar_Round_Start_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "HERoundStart", name);
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", gConVar_HE_Round_Health.IntValue);
					
					RemoveNades(i);
					
					int Primary = GetPlayerWeaponSlot(i, CS_SLOT_PRIMARY);
					int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
					int Grenade = GetPlayerWeaponSlot(i, CS_SLOT_GRENADE);
					
					if (Primary != -1)
					{
						RemovePlayerItem(i, Primary);
					}
					
					if (Secondary != -1)
					{
						RemovePlayerItem(i, Secondary);
					}
					
					if (Grenade != -1)
					{
						GivePlayerItem(i, "weapon_hegrenade");
					}
					else
					{
						GivePlayerItem(i, "weapon_hegrenade");
					}
				}
			}
			
			KnifeDamage = false;
			
			ServerCommand("sv_infinite_ammo 1");
			
			SetCvar("mp_buytime", "0");
		}
		if (Mode == -3)
		{
			SmokeRound = true;
			SmokeRound1 = false;
			
			if (gConVar_Round_Start_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "SmokeRoundStart", name);
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", gConVar_Smoke_Round_Health.IntValue);
					
					RemoveNades(i);
					
					int Primary = GetPlayerWeaponSlot(i, CS_SLOT_PRIMARY);
					int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
					int Grenade = GetPlayerWeaponSlot(i, CS_SLOT_GRENADE);
					
					if (Primary != -1)
					{
						RemovePlayerItem(i, Primary);
					}
					
					if (Secondary != -1)
					{
						RemovePlayerItem(i, Secondary);
					}
					
					if (Grenade != -1)
					{
						GivePlayerItem(i, "weapon_smokegrenade");
					}
					else
					{
						GivePlayerItem(i, "weapon_smokegrenade");
					}
				}
			}
			
			KnifeDamage = false;
			
			ServerCommand("sv_infinite_ammo 1");
			
			SetCvar("mp_buytime", "0");
		}
		if (Mode == -4)
		{
			FlashBangRound = true;
			FlashBangRound1 = false;
			
			if (gConVar_Round_Start_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "SmokeRoundStart", name);
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", gConVar_Flash_Round_Health.IntValue);
					
					RemoveNades(i);
					
					int Primary = GetPlayerWeaponSlot(i, CS_SLOT_PRIMARY);
					int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
					int Grenade = GetPlayerWeaponSlot(i, CS_SLOT_GRENADE);
					
					if (Primary != -1)
					{
						RemovePlayerItem(i, Primary);
					}
					
					if (Secondary != -1)
					{
						RemovePlayerItem(i, Secondary);
					}
					
					if (Grenade != -1)
					{
						GivePlayerItem(i, "weapon_flashbang");
					}
					else
					{
						GivePlayerItem(i, "weapon_flashbang");
					}
				}
			}
			
			KnifeDamage = false;
			
			ServerCommand("sv_infinite_ammo 1");
			
			SetCvar("mp_buytime", "0");
		}
		if (Mode == -5)
		{
			DecoyRound = true;
			DecoyRound1 = false;
			
			if (gConVar_Round_Start_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DecoyRoundStart", name);
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", gConVar_Decoy_Round_Health.IntValue);
					
					RemoveNades(i);
					
					int Primary = GetPlayerWeaponSlot(i, CS_SLOT_PRIMARY);
					int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
					int Grenade = GetPlayerWeaponSlot(i, CS_SLOT_GRENADE);
					
					if (Primary != -1)
					{
						RemovePlayerItem(i, Primary);
					}
					
					if (Secondary != -1)
					{
						RemovePlayerItem(i, Secondary);
					}
					
					if (Grenade != -1)
					{
						GivePlayerItem(i, "weapon_decoy");
					}
					else
					{
						GivePlayerItem(i, "weapon_decoy");
					}
				}
			}
			
			KnifeDamage = false;
			
			ServerCommand("sv_infinite_ammo 1");
			
			SetCvar("mp_buytime", "0");
		}
	}
}

//OnRoundEnd
//OnRoundEnd
//OnRoundEnd

public Action OnRoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	if (MolotovRound)
	{
		if (IsValidClient)
		{
			MolotovRound = false;
			MolotovRound1 = true;
			
			if (gConVar_Round_End_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "MolotovRoundEnd");
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", 100);
					
					RemoveNades(i);
				}
			}
			
			KnifeDamage = true;
			
			ServerCommand("sv_infinite_ammo 0");
			
			SetDefaultValue("mp_buytime");
		}
	}
	
	if (HERound)
	{
		if (IsValidClient)
		{
			HERound = false;
			HERound1 = true;
			
			if (gConVar_Round_End_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "HERoundEnd");
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", 100);
					
					RemoveNades(i);
				}
			}
			
			KnifeDamage = true;
			
			ServerCommand("sv_infinite_ammo 0");
			
			SetDefaultValue("mp_buytime");
		}
	}
	
	if (SmokeRound)
	{
		if (IsValidClient)
		{
			SmokeRound = false;
			SmokeRound1 = true;
			
			if (gConVar_Round_End_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "SmokeRoundEnd");
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", 100);
					
					RemoveNades(i);
				}
			}
			
			KnifeDamage = true;
			
			ServerCommand("sv_infinite_ammo 0");
			
			SetDefaultValue("mp_buytime");
		}
	}
	
	if (FlashBangRound)
	{
		if (IsValidClient)
		{
			FlashBangRound = false;
			FlashBangRound1 = true;
			
			if (gConVar_Round_End_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "FlashBangRoundEnd");
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", 100);
					
					RemoveNades(i);
				}
			}
			
			KnifeDamage = true;
			
			ServerCommand("sv_infinite_ammo 0");
			
			SetDefaultValue("mp_buytime");
		}
	}
	
	if (DecoyRound)
	{
		if (IsValidClient)
		{
			DecoyRound = false;
			DecoyRound1 = true;
			
			if (gConVar_Round_End_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DecoyRoundEnd");
			
			for (int i = 1; i <= MaxClients; i++)
			{
				if (IsValidClient(i))
				{
					SetEntProp(i, Prop_Data, "m_iHealth", 100);
					
					RemoveNades(i);
				}
			}
			
			KnifeDamage = true;
			
			ServerCommand("sv_infinite_ammo 0");
			
			SetDefaultValue("mp_buytime");
		}
	}
}

//SETCVAR AND SETDEFAULTVALUE

stock void SetCvar(const char[] scvar, const char[] svalue)
{
	ConVar cvar = FindConVar(scvar);
	if (cvar == INVALID_HANDLE)
		return;
	
	SetConVarString(cvar, svalue, true);
}

stock void SetDefaultValue(char[] scvar)
{
	ConVar cvar = FindConVar(scvar);
	if (cvar == INVALID_HANDLE)
		return;
	
	char szDefault[100];
	cvar.GetDefault(szDefault, sizeof(szDefault));
	
	SetConVarString(cvar, szDefault, true);
}

//REMOVE NADES

#define MAX_NADES 6

int grenade_offsets[] = { 15, 17, 16, 14, 18, 17 };

stock void RemoveNades(int client)
{
	while (RemoveWeaponBySlot(client, 3)) {  }
	
	for (int i = 0; i < MAX_NADES; i++)
	
	SetEntProp(client, Prop_Send, "m_iAmmo", 0, _, grenade_offsets[i]);
}

stock bool RemoveWeaponBySlot(int client, int slot)
{
	int ent = GetPlayerWeaponSlot(client, slot);
	if (IsValidEdict(ent))
	{
		RemovePlayerItem(client, ent);
		AcceptEntityInput(ent, "Kill");
		return true;
	}
	return false;
}

//KNIFE OFF

public void OnClientPutInServer(int client)
{
	SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
}

public Action TakeDamageHook(int client, int &attacker, int &inflictor, float &damage, int &damagetype)
{
	if (!KnifeDamage)
	{
		if ((client >= 1) && (client <= MaxClients) && (attacker >= 1) && (attacker <= MaxClients) && (attacker == inflictor))
		{
			char WeaponName[64];
			GetClientWeapon(attacker, WeaponName, sizeof(WeaponName));
			if (StrContains(WeaponName, "knife", false) != -1)
			{
				damage = 0.0;
				return Plugin_Changed;
			}
		}
	}
	return Plugin_Continue;
}

//IsValidClient
//IsValidClient
//IsValidClient

public bool IsValidClient(int client)
{
	return (1 <= client && client <= MaxClients && IsClientInGame(client));
}

//ADMIN MENU
//ADMIN MENU
//ADMIN MENU

public void OnAllPluginsLoaded()
{
	Handle topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
		OnAdminMenuReady(topmenu);
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "admingrenadesrounds", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "admingrenadesrounds", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_agrenadesrounds", TopMenuObject_Item, AdminMenu_GrenadesRounds, menu_category, "sm_agrenadesrounds", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T", "Grenades Rounds Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Grenades Rounds Title in Admin", param);
}

public void AdminMenu_GrenadesRounds(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Grenades Rounds Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		OpenGrenadesRoundsMenu(param);
} 